' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Dim objDSE, strDefaultDom, strDom
Dim objSchema, objPartitions, objRID, objDom, objInfra

Set objDSE = GetObject("LDAP://rootDSE")
strDefaultDom = objDSE.Get("defaultNamingContext")

strDom = 	InputBox("Enter the distinguished name of a domain" & _
	vbCrLf & "(e.g. " & strDefaultDom & ")", , strDefaultDom)

If strDom = "" Then WScript.Quit(1)		'user clicked Cancel

'Get the objects that have a pointer to each operations master
Set objSchema = GetObject("LDAP://" & _
	objDSE.Get("schemaNamingContext"))
Set objPartitions = GetObject("LDAP://CN=Partitions," & _
	objDSE.Get("configurationNamingContext"))
Set objRID = GetObject("LDAP://CN=RID Manager$,CN=System," & _
	strDom)
Set objDom = GetObject("LDAP://" & strDom)
Set objInfra = GetObject("LDAP://CN=Infrastructure," & strDom)

WScript.Echo vbCrLf & "== PER-FOREST =="
Call ShowFSMO("Schema", objSchema)
Call ShowFSMO("Domain Naming", objPartitions)
WScript.Echo vbCrLf & "== PER-DOMAIN =="
Call ShowFSMO("RID", objRID)
Call ShowFSMO("PDC", objDom)
Call ShowFSMO("Infrastructure", objInfra)

Sub ShowFSMO(strName, objPointerObj)
	Dim objNTDS, objDC, intGap

	Set objNTDS = GetObject("LDAP://" & _
		objPointerObj.Get("fSMORoleOwner"))  'pointer to CN=NTDS Settings
	Set objDC = GetObject(objNTDS.Parent)  'server object

	intGap = 14 - Len(strName)
	WScript.Echo strName & " Master: " & String(intGap, " ") & _
		objDC.dnsHostName
End Sub
