' -------------------------------------------------------------------------
'       From the book Inside Active Directory, ISBN 0-201-61621-1
'       Copyright (C) 2002 by Addison-Wesley
'       Script by Sakari Kouti (see http://www.kouti.com)
' You have a royalty-free right to use, modify, reproduce and distribute
' this script (and/or any modified version) in any way you find useful,
' provided that you agree that Addison-Wesley or Sakari Kouti has no
' warranty, obligations or liability for the script. If you modify
' the script, you must retain this copyright notice.
' -------------------------------------------------------------------------
Option Explicit

Dim wshNetwork, wshShell, objFS, objServerService, objFileShare
Dim objDSE, objContainer, objVolume

Set wshNetwork = WScript.CreateObject("WScript.Network")
Set wshShell = Wscript.CreateObject("Wscript.Shell")

'Create the folder
Set objFS = CreateObject("Scripting.FileSystemObject")
Call objFS.CreateFolder("C:\ShareDemo")

'Share the folder
Set objServerService = GetObject("WinNT://" & _
	wshNetwork.ComputerName & "/lanmanserver")
Set objFileShare = objServerService.Create("fileshare", "ShareDemo")
objFileShare.Path = "C:\ShareDemo"
objFileShare.MaxUserCount = -1		'unlimited number of users
objFileShare.Description = "You should remove this demo share"
objFileShare.SetInfo

'Publish the share in Active Directory
Set objDSE = GetObject("LDAP://rootDSE")
Set objContainer = GetObject("LDAP://CN=Users," & _
	objDSE.Get("defaultNamingContext"))
Set objVolume = objContainer.Create("volume", "CN=ShareDemo")
Call objVolume.Put("uNCName", _
	"\\" & wshNetwork.ComputerName & "\ShareDemo")
Call objVolume.Put("keywords", Array("demos", "sharing"))
objVolume.SetInfo
